package bin_trees;

import org.junit.Test;

import static org.junit.Assert.*;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.Deque;

/**
 * @author 
 *
 */
public class ExpressionTreeTest {

	/**
	 *           +
	 *        -      6
	 *      4    2 
	 */
	private VarBinNode et = new VarIntlNode('+',
            new VarIntlNode('-', new VarLeafNode("4"), new VarLeafNode("2")),
            new VarLeafNode("6"));
	
//	@Test
//	public void testPreOrderTraversal() {
//		ByteArrayOutputStream captor = new ByteArrayOutputStream();
//		System.setOut(new PrintStream(captor));
//		// preorder traversal
//		et.traverse();
//		String preorderSequence = captor.toString().trim();
//		assertEquals("correct preorder traversal sequence","+-426", preorderSequence );
//	}
//
//	@Test
//	public void testInOrderTraversal() {
//		ByteArrayOutputStream captor = new ByteArrayOutputStream();
//		System.setOut(new PrintStream(captor));
//		// preorder traversal
//		et.traverse();
//		String preorderSequence = captor.toString().trim();
//		assertEquals("correct inorder traversal sequence", "4-2+6", preorderSequence);
//	}
	
	@Test
	public void testPostOrderTraversal() {
		ByteArrayOutputStream captor = new ByteArrayOutputStream();
		System.setOut(new PrintStream(captor));
		// preorder traversal 
		et.traverse();
		String preorderSequence = captor.toString().trim();
		assertEquals("correct postorder traversal sequence", "42-6+", preorderSequence);
	}

	
	@Test
	public void testEvaluateExpressionTree() {
		Deque<VarBinNode> q = EvaluateExpressionTree.PostTraverse(et);
        double val = EvaluateExpressionTree.Evaluate(q);
        assertEquals("correct evaluation of the expression tree", 8, val );
	}
	
}


