package bin_trees;

/**
 * Internal Node class
 * @author 
 *
 */
public class VarIntlNode
    implements VarBinNode
{
    private VarBinNode left;     // Left child
    private VarBinNode right;    // Right child
    private Character  operator; // Operator value


    /**
     * Constructor
     * @param op the operator stored in this node
     * @param l the left child of this Node
     * @param r the right child of this node
     */
    public VarIntlNode(Character op, VarBinNode l, VarBinNode r)
    {
        operator = op;
        left = l;
        right = r;
    }


    /**
     * @return the left child of this Node
     */
    public VarBinNode leftchild()
    {
        return left;
    }


    /**
     * @return the right child of this node
     */
    public VarBinNode rightchild()
    {
        return right;
    }


    /**
     * @return the operator stored in this node
     */
    public Character value()
    {
        return operator;
    }


    @Override
    public boolean isLeaf()
    {
        return false;
    }


    /**
     * Provides a post-order traversal as written. To make it pre- or in-
     * order, move the print statement around in the method.
     */
    @Override
    public void traverse()
    {
    	//recursively call traverse on the left and the 
    	// right children
    	left.traverse();
    	right.traverse();
    	// postorder
    	System.out.print(operator);
        

    }

}
